(*
 Sunae Seo, The LET Project, KAIST

 Copyright(c) 2001 Research On Program Analysis System
 National Creative Research Initiative Center
 Korea Advanced Institute of Science & Technology
 http://ropas.kaist.ac.kr

 All rights reserved. This file is distributed under the terms of
 an Open Source License.
*)

(* configuration misc file for c parser *)


structure CpConfig =
struct
   val symbol_length = 256
   val on_print_parsetree = ref false 
   val on_print_lex = ref false
   val filename = ref ""
   
   fun anony x = 
     (if Filename.check_suffix x ".c" 
         orelse Filename.check_suffix x ".h"
      then filename := x
      else raise (Arg.Bad("don't know what to do with " ^ x)))

   val usage = "Usage: c_parser <options> <files> \nOptions are:" 

   val arglist = [
    ("-pp", Arg.Set on_print_parsetree, "Print parse tree"),
    ("-pl", Arg.Set on_print_lex, "Print lexing tokens")
   ]
end 
