(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the Q Public License version 1.0.               *)
(*                                                                     *)
(***********************************************************************)

(* $Id: location.n,v 1.1.1.1 2001/02/26 05:38:25 judaigi Exp $ *)
signature LocationSig =
sig
type t = { loc_start: int, loc_end: int, loc_ghost: bool }

val none: t
val print: t -> unit
val symbol_rloc: unit -> t
val rhs_loc: int -> t

val location_field_loc_start: t -> int
val location_field_loc_end: t -> int
val location_to_location: int * int * int -> t
end

structure Location = 
struct
type t = { loc_start: int, loc_end: int, loc_ghost: bool } 
val none = { loc_start = -1, loc_end = -1, loc_ghost = true }
fun print _ = ()
fun symbol_rloc () = none
fun rhs_loc _ = none
fun location_field_loc_start _ = 1
fun location_field_loc_end _ = 1
fun location_to_location (_,_,_) = none
end
