(*
 JungTaek Kim, The LET Project, KAIST

 Copyright(c) 2000 Research On Program Analysis System
 National Creative Research Initiative Center
 Korea Advanced Institute of Science & Technology
 http://ropas.kaist.ac.kr

 All rights reserved. This file is distributed under the terms of
 an Open Source License.
*)

structure Parse = struct

open Location

fun batch_parse lexbuf = 
  ( let val ast = N_parser.batch_parse N_lexer.token lexbuf
	 in PostParse.check_topdec ast;
        Parsing.clear_parser();
        ast
	end )
  handle
      err as N_lexer.Error(N_lexer.Unterminated_comment, _, _) => raise err
    | err as N_lexer.Error(N_lexer.Unterminated_string, _, _) => raise err
    | err as N_lexer.Error(_, _, _) => raise err
    | err as SyntaxErr.Error _ => raise err
    | Parsing.Parse_error | SyntaxErr.Escape_error =>
        let val loc = Location.location_to_location
		              ( Lexing.lexeme_start lexbuf,
                        Lexing.lexeme_end lexbuf,
		                false )
		 in raise(SyntaxErr.Error(SyntaxErr.Unknown(loc)))
		end

end
