(*
 Sungsoon Jang, The LET Project, KAIST

 Copyright(c) 2001 Research On Program Analysis System
 National Creative Research Initiative Center
 Korea Advanced Institute of Science & Technology
 http://ropas.kaist.ac.kr

 All rights reserved. This file is distributed under the terms of
 an Open Source License.
*)

structure Scm=
struct 

type exp = Var of string
		 | Lit of lit
         | Lst of exp list
		 | LstnPair of exp list * exp
		 | Quote of exp
		 | QQuote of exp
		 | UQuote of exp
		 | UQSplice of exp
         | Vector of exp list
and  lit = Int of int
		 | Bool of bool
		 | Real of real
		 | Char of string
		 | String of string

fun gp Var s    = s
  | gp Lit n	= glit n
  | gp Lst l	= "("^List.fold_right (fn x s => gp x ^" "^ s) l ""^")"
  | gp LstnPair(l,e) = 
  	  "("^List.fold_right (fn x s => gp x ^" "^ s) l ""^" . "^gp e^")"
  | gp Quote e	= "'"^gp e
  | gp QQuote e = "`"^gp e
  | gp UQuote e = ","^gp e
  | gp UQSplice e = ",@"^gp e
  | gp Vector l = "#("^List.fold_right (fn x s => gp x ^" "^ s) l ""^")"
and glit Int n	= string_of_int n
  | glit Bool b = if b then "#t" else "#f"
  | glit Real f = string_of_float f
  | glit Char s = "#\\"^s
  | glit String s = "\""^s^"\""
fun pp e = print_string(gp e)

end

