/*
 Sungsoon Jang, The LET Project, KAIST

 Copyright(c) 2001 Research On Program Analysis System
 National Creative Research Initiative Center
 Korea Advanced Institute of Science & Technology
 http://ropas.kaist.ac.kr

 All rights reserved. This file is distributed under the terms of
 an Open Source License.
*/

%{
open Scm
%}

%token DOT LP RP SLP EOF QUOTE QQUOTE UQUOTE UQSPLICE
%token <string> ID
%token <int> INT
%token <real> FLOAT
%token <string> CHAR
%token <bool> BOOL
%token <string> STRING

%nonassoc ID, LP, RP, EOF, INT, FLOAT, CHAR, BOOL, STRING
%start goal
%type <Scm.exp list> goal
%%
goal		: exprs EOF   	{$1}
    		;
exprs		: expr			{[$1]}
			| expr exprs 	{$1::$2}
			;
expr		: ID			{Var($1)}
			| lit			{Lit($1)}
			| list			{$1}
			| vector		{$1}
			;
lit 		: INT			{Int($1)}
			| BOOL			{Bool($1)}
			| FLOAT 		{Real($1)}
			| CHAR			{Char($1)}
			| STRING		{String($1)}
			;
list		: LP RP			{Lst []}
			| LP exprs RP	{Lst $2}
			| LP exprs DOT expr RP	{LstnPair($2,$4)}
			| QUOTE expr	{Quote $2}
			| QQUOTE expr	{QQuote $2}
			| UQUOTE expr	{UQuote $2}
			| UQSPLICE expr	{UQSplice $2}
			;
vector		: SLP RP		{Vector []}
			| SLP exprs RP	{Vector $2}
			;
%%


